# Notas musicais
[![Documentation Status](https://readthedocs.org/projects/notas-musicais-hcca/badge/?version=latest)](https://notas-musicais-hcca.readthedocs.io/en/latest/?badge=latest)
[![CI](https://github.com/HenriqueCCdA/notas-musicais/actions/workflows/pipeline.yaml/badge.svg)](https://github.com/HenriqueCCdA/notas-musicais/actions/workflows/pipeline.yaml)
[![codecov](https://codecov.io/gh/HenriqueCCdA/notas-musicais/branch/main/graph/badge.svg?token=l2XJAZzrrH)](https://codecov.io/gh/HenriqueCCdA/notas-musicais)

Notas musicais é um CLI para ajudar na formação de escalas, acordes e campos harmônicos.

Toda a aplicação é baseada em um comando chamado `notas-musicas`. Esse comando tem um suubcomando relacionado a cada acção que a aplicação pode realizar.
Como `escalas`, `acordes`e `campo-harmonico`.

Para instalação do cli do projeto recomendamos que use o `pipx` para fazer essa instalação:

```bash
pipx install notas-musicais
```

Embora isso seja somente  uma recomendação! Você também pode instalar o projeto com o gerenciador de sua preferência. Como o pip:


```bash
pip install notas-musicais
```

## como usar ?

### Escalas

Você pode chamar  as escalas via linha de comando. Por exemplo.

```bash
notas-musicais escalas
```

Retornando os graus e as notas correspondentes e essa escala:

```
┏━━━┳━━━━┳━━━━━┳━━━━┳━━━┳━━━━┳━━━━━┓
┃ I ┃ II ┃ III ┃ IV ┃ V ┃ VI ┃ VII ┃
┡━━━╇━━━━╇━━━━━╇━━━━╇━━━╇━━━━╇━━━━━┩
│ D │ E  │ F#  │ G  │ A │ B  │ C#  │
└───┴────┴─────┴────┴───┴────┴─────┘
```

#### Alteração da tonica da escala

O primeiro parãmetro do CLI é a tônica da escala que desaja exibir. Desta forma, você pode alterar a escala retornada:

```bash
poetry run notas-musicais escalas F#
```

Resultado em:

```
━━━━┳━━━━┳━━━━━┳━━━━┳━━━━┳━━━━┳━━━━━┓
┃ I  ┃ II ┃ III ┃ IV ┃ V  ┃ VI ┃ VII ┃
┡━━━━╇━━━━╇━━━━━╇━━━━╇━━━━╇━━━━╇━━━━━┩
│ F# │ G# │ A#  │ B  │ C# │ D# │ F   │
└────┴────┴─────┴────┴────┴────┴─────┘
```

#### Alteração da tonalidade da escala

Você pode alterar a tonalidade da escala também! Esse é o segundo parâmetro da linha de comando. Por exemmplo, a escala de `D#` menor:

```bash
poetry run notas-musicais escalas D# menor
```

```
┏━━━━┳━━━━┳━━━━━┳━━━━┳━━━━┳━━━━┳━━━━━┓
┃ I  ┃ II ┃ III ┃ IV ┃ V  ┃ VI ┃ VII ┃
┡━━━━╇━━━━╇━━━━━╇━━━━╇━━━━╇━━━━╇━━━━━┩
│ D# │ F  │ F#  │ G# │ A# │ B  │ C#  │
└────┴────┴─────┴────┴────┴────┴─────┘
```

### Acordes

Uso básico

```bash
notas-musicais acorde
┏━━━┳━━━━━┳━━━┓
┃ I ┃ III ┃ V ┃
┡━━━╇━━━━━╇━━━┩
│ C │ E   │ G │
└───┴─────┴───┘
```



#### Variações na cifra

```bash
notas-musicais acorde C+
┏━━━┳━━━━━┳━━━━┓
┃ I ┃ III ┃ V+ ┃
┡━━━╇━━━━━╇━━━━┩
│ C │ E   │ G# │
└───┴─────┴────┘
```

Até o momento você usar acordes maiores, menores, dimunito e aumentados

### Campo harmônico

Você pode chamar os campos harmônicos via o subcomando `campo-harmonico`. Por exemplo:

```bash
notas-musicais campo-harmonico

┏━━━┳━━━━┳━━━━━┳━━━━┳━━━┳━━━━┳━━━━━━┓
┃ I ┃ ii ┃ iii ┃ IV ┃ V ┃ vi ┃ vii° ┃
┡━━━╇━━━━╇━━━━━╇━━━━╇━━━╇━━━━╇━━━━━━┩
│ C │ Dm │ Em  │ F  │ G │ Am │ B°   │
└───┴────┴─────┴────┴───┴────┴──────┘
```

Por padrão os parâmetros utilizados são a tômica de `C` e o campo harmônico `maior`.

#### Alteração nos campos harmônicos

Você pode alterar os parâmetros da tônica e da tonalidade.

```bash
notas-musicais campo-harmonico [TONICA] [TONALIDADE]
```

##### Alteração na tônica do campo

Um exemplo com o campo harmoncio de `E`

```bash
notas-musicais campo-harmonico E

┏━━━┳━━━━━┳━━━━━┳━━━━┳━━━┳━━━━━┳━━━━━━┓
┃ I ┃ ii  ┃ iii ┃ IV ┃ V ┃ vi  ┃ vii° ┃
┡━━━╇━━━━━╇━━━━━╇━━━━╇━━━╇━━━━━╇━━━━━━┩
│ E │ F#m │ G#m │ A  │ B │ C#m │ D#°  │
└───┴─────┴─────┴────┴───┴─────┴──────┘
```

##### Alteração da tonalidade do campo

Um exemplo utilizando o campo harmônico de `E` na tonalidade `menor`:

```bash
notas-musicais campo-harmonico E menor

┏━━━━┳━━━━━┳━━━━━┳━━━━┳━━━━┳━━━━┳━━━━━┓
┃ i  ┃ ii° ┃ III ┃ iv ┃ v  ┃ VI ┃ VII ┃
┡━━━━╇━━━━━╇━━━━━╇━━━━╇━━━━╇━━━━╇━━━━━┩
│ Em │ F#° │ G   │ Am │ Bm │ C  │ D   │
└────┴─────┴─────┴────┴────┴────┴─────┘
```

## Mais informações sobre o CLI

Para descobrir outras opções, você pode usar a flag `--help`.

```bash
notas-musicais --help

Usage: notas-musicais [OPTIONS] COMMAND [ARGS]...

╭─ Commands ──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────╮
│ acorde                                                                                                                                          │
│ campo-harmonico                                                                                                                                 │
│ escala                                                                                                                                          │
╰─────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────╯
```

### Mais informações sobre os subcomandos

As informações sobre os subcamandos podem ser acessadas uasndo a flag `--help`após o nome do parâmetro. Um exemplo do uso do `help` nos campos harmônicos

```bash
notas-musicais campo-harmonico --help

Usage: notas-musicais campo-harmonico [OPTIONS] [TONICA] [TONALIDADE]

╭─ Arguments ─────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────╮
│   tonica          [TONICA]      Tônica do campo harm^monico [default: C]                                                                        │
│   tonalidade      [TONALIDADE]  Tonalidade do campo harmônico [default: maior]                                                                  │
╰─────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────╯
```
